

#ifndef __H264__ENCODE__LIB__TYPE__H__
#define __H264__ENCODE__LIB__TYPE__H__



#include "drv_display.h"

typedef struct VIDEO_ENCODE_FORMAT
{
    unsigned int       codec_type;
    signed int		width;
	signed int		height;
	
    unsigned int       frame_rate;
    signed int		color_format;
	signed int		color_space;
    signed short		qp_max;					// 40
	signed short		qp_min;					// 20
    signed int       avg_bit_rate;       	// average bit rate
//    signed int       max_bit_rate;       	// maximum bit rate
    
	signed int		maxKeyInterval;
    //define private information for video decode
//    __u16       video_bs_src;       // video bitstream source
//    void        *private_inf;       // video bitstream private information pointer
//    signed short       priv_inf_len;       // video bitstream private information length

	// star add
	unsigned char		profileIdc;
	unsigned char		levelIdc;

	unsigned int		src_width;
	unsigned int		src_height;

	int			scale_factor;
	double		focal_length;

	unsigned int		quality;			// for jpeg encoder
	unsigned int		orientation;		// for jpeg encoder

	// gps exif
	unsigned char		enable_gps;
	double      gps_latitude;  //
	double		gps_longitude;  //
	long        gps_altitude;  
	long        gps_timestamp;
	char		gps_processing_method[100]; 
	unsigned int       thumb_width;
	unsigned int       thumb_height;
} __video_encode_format_t;


typedef enum
{
    BT601 = 0,
	BT709,
	YCC,
	VXYCC
}__cs_mode_t;

typedef enum __PIXEL_YUVFMT                         /* pixel format(yuv)                                            */
{
    PIXEL_YUV444 = 0x10,                            /* only used in scaler framebuffer                              */
    PIXEL_YUV422,
    PIXEL_YUV420,
    PIXEL_YUV411,
    PIXEL_CSIRGB,
    PIXEL_OTHERFMT
}__pixel_yuvfmt_t;

typedef enum
{
    M_ENCODE = 0,             
    M_ISP_THUMB,             
    M_ENCODE_ISP_THUMB,     
    M_UNSUPPORT,
} __venc_output_mod_t;

typedef enum __COLOR_SPACE
{
#ifdef __CHIP_VERSION_F20
    COLOR_SPACE_BT601 = BT601,
    COLOR_SPACE_BT709 = BT709,
#else
    COLOR_SPACE_BT601 = DISP_BT601,
    COLOR_SPACE_BT709 = DISP_BT709,
#endif
    COLOR_SPACE_,
}__color_space_t;

typedef struct _media_file_inf_t
{
	// video 
    signed int nHeight;
	signed int nWidth;
	signed int uVideoFrmRate;
	signed int create_time;
	signed int maxKeyInterval;

	// audio
	int channels;			
	int bits_per_sample;	
	int frame_size;		
	int sample_rate;		
}_media_file_inf_t;

typedef struct V4L2BUF_t
{
	unsigned int	addrPhyY;		// physical Y address of this frame
	int 			index;			// DQUE id number
	long long		timeStamp;		// time stamp of this frame
}V4L2BUF_t;

#endif	// __H264__ENCODE__LIB__TYPE__H__

